SystemOrganization addCategory: #ConfigurationOfSmaCC!

Object subclass: #ConfigurationOfSmaCC
	instanceVariableNames: 'project'
	classVariableNames: 'LastVersionLoad'
	poolDictionaries: ''
	category: 'ConfigurationOfSmaCC'!

!ConfigurationOfSmaCC class methodsFor: 'private' stamp: 'DamienPollet 3/7/2010 17:17'!
bootstrapPackage: aString from: aPath 
	| repository version |
	repository := MCHttpRepository
				location: aPath
				user: ''
				password: ''.
	repository
		versionReaderForFileNamed: aString , '.mcz'
		do: [:reader | 
			version := reader version.
			version load.
			version workingCopy repositoryGroup addRepository: repository]! !

!ConfigurationOfSmaCC class methodsFor: 'private' stamp: 'DamienPollet 3/7/2010 17:17'!
ensureMetacello
	"Bootstrap Gofer (if necessary), bootstrap ConfigurationOfMetacello (using old Gofer API), then load the latest 
	version of Metacello itself."

	Smalltalk at: #MetacelloProject ifAbsent: [
		Smalltalk at: #Gofer ifAbsent: [
			"Current version of Gofer from which to bootstrap - as of 1.0-beta.21"
			self bootstrapPackage: 'Gofer-Core-lr.115' from: 'http://seaside.gemstone.com/ss/metacello' ].
		Smalltalk at: #Gofer ifPresent: [:goferClass | | gofer |
			gofer := goferClass new
				url: 'http://seaside.gemstone.com/ss/metacello';
				yourself.
			[ gofer addPackage: 'ConfigurationOfMetacello' ] on: Warning do: [:ex | ex resume ].
			gofer load ].
		"load 'default' group of Metacello"
		(Smalltalk at: #ConfigurationOfMetacello) perform: #load ]! !

!ConfigurationOfSmaCC class methodsFor: 'metacello tool support' stamp: 'DamienPollet 3/7/2010 17:17'!
isMetacelloConfig
	"Answer true and the Metacello tools will operate on you"
	
	^true! !

!ConfigurationOfSmaCC class methodsFor: 'metacello tool support' stamp: 'DamienPollet 3/7/2010 17:17'!
lastMetacelloVersionLoad
	"Answer the last version loaded and the list of packages loaded for that version."

	LastVersionLoad == nil ifTrue: [ LastVersionLoad := nil -> 'default' ].
	^LastVersionLoad! !

!ConfigurationOfSmaCC class methodsFor: 'loading' stamp: 'DamienPollet 3/7/2010 17:17'!
load
	"self load"

	^self project latestVersion load! !

!ConfigurationOfSmaCC class methodsFor: 'metacello tool support' stamp: 'DamienPollet 3/7/2010 17:17'!
metacelloVersion: versionString loads: anArrayOrString
	"Stash the last version loaded and the list of packages loaded for that version. The list
	 of packages will be used by the tools when doing 'Load Package Version'"

	LastVersionLoad := versionString -> anArrayOrString! !

!ConfigurationOfSmaCC class methodsFor: 'accessing' stamp: 'DamienPollet 3/7/2010 17:17'!
project

	^self new project! !

!ConfigurationOfSmaCC class methodsFor: 'unloading Metacello' stamp: 'DamienPollet 3/7/2010 17:17'!
unloadMetacello

	Smalltalk at: #ConfigurationOfMetacello ifPresent: [:cls | cls unloadMetacello ]! !

!ConfigurationOfSmaCC methodsFor: 'baselines' stamp: 'DamienPollet 3/7/2010 18:59'!
baseline01: spec
	<version: '0.1-baseline'>
	
	spec for: #common do: [
		spec blessing: #baseline.
		spec repository: 'http://www.squeaksource.com/SmaccDevelopment'.

		spec
			package: 'SmaCC';
			package: 'SmaCCDev' with: [ spec requires: 'SmaCC' ].
		
		spec
			group: 'default' with: #('Runtime');
			group: 'Runtime' with: #('SmaCC');
			group: 'Tools' with: #('SmaCCDev')
	]! !

!ConfigurationOfSmaCC methodsFor: 'accessing' stamp: 'DamienPollet 3/7/2010 17:17'!
project

	^ project ifNil: [ | constructor |
		"Bootstrap Metacello if it is not already loaded"
		self class ensureMetacello.
		"Construct Metacello project"
		constructor := (Smalltalk at: #MetacelloVersionConstructor) on: self.
		project := constructor project.
		project loadType: #linear. "change to #atomic if desired"
		project ]! !

!ConfigurationOfSmaCC methodsFor: 'versions' stamp: 'DamienPollet 3/7/2010 18:57'!
version01: spec
	<version: '0.1' imports: #('0.1-baseline')>
	
	spec for: #common do: [
		spec
			blessing: #release;
			author: 'DamienPollet';
			description: 'Make SmaCC available via Metacello'
	]! !
